#include <conio.h>
#include <stdio.h>
#include <STRING.H>
#include <ctype.h>
#include <windows.h>

static int s_Seconds = 10;
static char s_Message[256];

int main( int argc, char* argv[] )
{
	int nRetCode = 2;		// No answer - Timeout
	char answer = '\0';
	// Parse the command line - Task [ss] [text] 
	// ss default to 10 seconds

	if( argc == 1 ) {
		// No parameters
		printf( "TASK version 1.0, created by Bob @ grsoftware.net 23 July 2012, ALL RIGHTS RESERVED!\n" );
		printf( "Timed Ask for batch file. Error level 0=No, 1=Yes, 2=No Answer \n\n" );
		printf( "USAGE: Task [<n>] [<q>]\n" );
		printf( "Where:\t<n> = Time limit in seconds (default 10)\n" );
		printf( "\t<q> = Question to ask\n\n" );
		return 2;
	}

	
	strcpy( s_Message, "Enter you Choice" );

	if( argc >= 2 ) {
		// Verify if the second parameter is a number of text
		int i = 1;
		if( isdigit(argv[1][0]) ) {
			// It's a number = seconds
			s_Seconds = atoi( argv[1] );
			i = 2;
		}

		*s_Message = '\0';
		while( argv[i] != '\0' ) {
			strcat( s_Message, argv[i++] );
			strcat( s_Message, " " );
		}
	}

	// Print message
	printf( s_Message );
	printf( " (Y/N)? " );
	
	// Wait loop
	DWORD Timeout = GetTickCount() + s_Seconds * 1000;
	DWORD t, s = (Timeout - GetTickCount()) / 1000;
	while( answer == '\0' && GetTickCount() < Timeout ) {
		t = (Timeout - GetTickCount()) / 1000;
		if( t != s && t < 10 ) {
			s = t;
			printf( "%d\b", s );
		}
		if( kbhit() )
			answer = getch();
	}

	if( answer == 'Y' || answer == 'y' )
		nRetCode = 1;
	else if( answer == 'N' || answer == 'n' )
		nRetCode = 0;

	return nRetCode;
}
